mod Ex03b logic: 'cl'

incl Mtex

incl Mauxb

loc rem 
  3. CVICENIE Z PREDMETU SPECIFIKACIA A VERIFIKACIA PROGRAMOV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 3.3.2005
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov
  ******************************************************************************
  PMAIL: svp@nw.fmph.uniba.sk
         SUBJECT: prihlasenie sa do skupiny [14:50,16:30,18:10]
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/svp

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane rekurzii na 
  notacii. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subor(y) \it  ex03*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Recursion on Notation.  \end 

rem 
  \para \bf  Subsection. Dyadic Arithmetic.  \end 

rem 
  \para \bf  [CL] Dyadic successors.  \end 
  \eq* 
    S1(x) = 2*x+1
  \end
  \eq* 
    S2(x) = 2*x+2
  \end
  \para The functions are defined in the module \ft Standard \end. 

rem 
  \para \bf  Justification of dyadic case analysis.  \end Prove 
  \eq Dyadic_case_analysis
    x = 0 \/ \e y x = S1(y) \/ \e y x = S2(y)
  \end
  \para \it  Hint.  \end See the theorem \ft Quotient_remainder \end in the 
  module \ft Maux \end. 

thm Dyadic_case_analysis
  x = 0 \/ \e y x = S1(y) \/ \e y x = S2(y)

rem 
  \para \bf  [CL] Dyadic case analysis.  \end Syntax: 
  \items 
   \item \para The command \it  case  \end \ft N2 \end \it  ;  \end 
         \ft Tex0_tau \end invokes dyadic case analysis on the term 
         \ft Tex0_tau \end. 
  \end
  \para The predicate \ft N2 \end is defined in the module \ft Standard \end. 

rem 
  \para \bf  Justification of dyadic induction.  \end Reduce dyadic induction to 
  complete induction. 

theory Dyadic_induction_by_complete_induction

pred A 'Tex_p1_phi_subst'

axiom Base_case
  A(0)

axiom Inductive_step1
  A(x) -> A S1(x)

axiom Inductive_step2
  A(x) -> A S2(x)

thm Conclusion
  A(x)

end theory Dyadic_induction_by_complete_induction

rem 
  \para \bf  [CL] Dyadic induction.  \end Syntax: 
  \items 
   \item \para The command \it  ind  \end \ft N2 \end \it  ;  \end \ft x \end 
         invokes dyadic induction on \ft x \end with the induction formula 
         \ft Tex2_bappl1(Tex0_phi,x) \end, where 
         \ft Tex2_bappl1(Tex0_phi,x) \end is the current goal possibly with 
         additional free variables as parameters. 
   \item \para The command \it  ind  \end \ft N2 \end \it  ;  \end \ft x \end 
         \it  ;  \end \ft Tex1_hat(y) \end invokes dyadic induction on 
         \ft x \end with the induction formula 
         \ft Tex2_forall(Tex1_hat(y),Tex3_bappl2(Tex0_phi,x,Tex1_hat(y))) \end, 
         where \ft Tex3_bappl2(Tex0_phi,x,Tex1_hat(y)) \end is the current goal 
         possibly with additional free variables as parameters. 
  \end

rem 
  \para \bf  Dyadic size.  \end 

fun Dsz 'Tex_f1_n2_sz'
  Dsz(0) = 0
  Dsz S1(x) = Dsz(x)+1
  Dsz S2(x) = Dsz(x)+1

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Dsz_zero
    Dsz(x) = 0 <-> x = 0
  \end
  \eq Dsz_one
    Dsz(x) = 1 <-> x = 1 \/ x = 2
  \end

thm Dsz_zero
  Dsz(x) = 0 <-> x = 0

thm Dsz_one
  Dsz(x) = 1 <-> x = 1 \/ x = 2

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Dsz_exp
    Dsz(x) = n <-> Exp(2,n) <= x+1 & x+1 < Exp(2,n+1)
  \end
  \para \it  Hint.  \end Prove the claim by induction on \ft n \end. 

thm Dsz_exp
  Dsz(x) = n <-> Exp(2,n) <= x+1 & x+1 < Exp(2,n+1)

rem 
  \para \bf  Dyadic concatenation.  \end 

fun/2 Dconc 'Tex_f2_n2_conc'
  Dconc(x,0) = x
  Dconc(x,S1(y)) = S1 Dconc(x,y)
  Dconc(x,S2(y)) = S2 Dconc(x,y)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Dconc_expl
    Dconc(x,y) = x*Exp(2,Dsz(y))+y
  \end
  \eq Dconc_zero
    Dconc(x,y) = 0 <-> x = 0 & y = 0
  \end
  \eq Dconc_left_zero
    Dconc(0,y) = y
  \end
  \eq Dconc_assoc
    Dconc(Dconc(x,y),z) = Dconc(x,Dconc(y,z))
  \end
  \eq Dconc_szd
    Dsz Dconc(x,y) = Dsz(x)+Dsz(y)
  \end

thm Dconc_expl
  Dconc(x,y) = x*Exp(2,Dsz(y))+y

thm Dconc_zero
  Dconc(x,y) = 0 <-> x = 0 & y = 0

thm Dconc_left_zero
  Dconc(0,y) = y

thm Dconc_assoc
  Dconc(Dconc(x,y),z) = Dconc(x,Dconc(y,z))

thm Dconc_szd
  Dsz Dconc(x,y) = Dsz(x)+Dsz(y)

rem 
  \para \bf  Dyadic reversal.  \end 

fun Drev 'Tex_f1_n2_rev'
  Drev(0) = 0
  Drev S1(x) = Dconc(1,Drev(x))
  Drev S2(x) = Dconc(2,Drev(x))

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Drev_zero
    Drev(x) = 0 <-> x = 0
  \end
  \eq Drev_dconc
    Drev Dconc(x,y) = Dconc(Drev(y),Drev(x))
  \end
  \eq Drev_drev
    Drev Drev(x) = x
  \end
  \eq Drev_surjective
    \e y Drev(y) = x
  \end
  \eq Drev_injective
    Drev(x) = Drev(y) -> x = y
  \end
  \eq Drev_szd
    Dsz Drev(x) = Dsz(x)
  \end

thm Drev_zero
  Drev(x) = 0 <-> x = 0

thm Drev_dconc
  Drev Dconc(x,y) = Dconc(Drev(y),Drev(x))

thm Drev_drev
  Drev Drev(x) = x

thm Drev_surjective
  \e y Drev(y) = x

thm Drev_injective
  Drev(x) = Drev(y) -> x = y

thm Drev_szd
  Dsz Drev(x) = Dsz(x)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Dconc_cancel_right
    Dconc(y,x) = Dconc(z,x) -> y = z
  \end
  \eq Dconc_cancel_left
    Dconc(x,y) = Dconc(x,z) -> y = z
  \end

thm Dconc_cancel_right
  Dconc(y,x) = Dconc(z,x) -> y = z

thm Dconc_cancel_left
  Dconc(x,y) = Dconc(x,z) -> y = z

