mod Mauxb logic: 'cl'

incl Mtex

rem 
  \para \bf  Additional properties of comparision predicates.  \end 

thm Le_qr
  y > 0 & r1 < y & r2 < y -> q1*y+r1 <= q2*y+r2 <-> 
  q1 < q2 \/ q1 = q2 & r1 <= r2
proof 
 split* q1*y+r1 <= q2*y+r2 <-> q1 < q2 \/ q1 = q2 & r1 <= r2.2,0,0
  ind N; r1; r2 @ 0; r1
   inv* q1 < q2
    cut r2 = 0
     proved
     proved..
   case Trich; q1,q2 @ x,y1; x,y1; x,y1
    proved
    proved
    cut r2 = 0
     proved
     inst \a r2~(r2 < y & q1*y+r1 <= q2*y+r2); r2-1 proved....
  split q1 < q2 \/ q1 = q2 & r1 <= r2.4,0,0,0
   ind N; r1; r2 @ 0; r1
    proved
    cut r2 = 0
     inv* q1*y+r1 < q2*y proved.
     inst \a r2(r2 < y -> q1*y+r1 <= q2*y+r2); r2-1 proved...
   proved...

thm Lt_qr
  y > 0 & r1 < y & r2 < y -> q1*y+r1 < q2*y+r2 <-> q1 < q2 \/ q1 = q2 & r1 < r2
proof 
 split* q1*y+r1 < q2*y+r2 <-> q1 < q2 \/ q1 = q2 & r1 < r2.2,0,0
  ind N; r1; r2 @ 0; r1
   cut r2 = 0
    proved
    proved.
   cut r2 = 0
    proved
    inst \a r2(r2 < y & q1*y+r1 < q2*y+r2 -> q1 = q2 & r1 < r2) \/ q1 < q2.0:3,
                                                                             0,
                                                                             1,
                                                                             0; r2-1
     split q1 = q2 & r1+1 < r2 \/ q1 < q2.4,0,0,0
      proved
      proved....
  split q1 < q2 \/ q1 = q2 & r1 < r2.4,0,0,0
   ind N; r1; r2 @ 0; r1
    cut r2 = 0
     proved
     proved.
    cut r2 = 0
     proved
     inst \a r2(r2 < y -> q1*y+r1 < q2*y+r2); r2-1 proved...
   proved...

rem 
  \para \bf  Quotient and remainder.  \end 

thm Quotient_remainder
  y > 0 -> \e q\e r(x = q*y+r & r < y)
proof 
 indm x @ x1
  case Dich; y,x @ x1,y1; x1,y1
   inst \a x1(x1 < x -> \e r(\e q x1 = y*q+r & r < y)).0; x-y
    eigen \e r(\e q x = y+y*q+r & r < y).0:0,3,0,1,0; r,q
     inst* \e r1(\e q1 q*y+r+y = y*q1+r1 & r1 < y):0,3,0,1,0; r; q+1 proved...
   inst* \e r(\e q x = y*q+r & r < y):0,3,0,1,0; x; 0 proved....

thm Quotient_div
  y > 0 -> \e r(x = x/y*y+r & r < y)
proof 
 use Quotient_remainder.0; y; x
  eigen \e r(\e q x = y*q+r & r < y).0:0,3,0,1,0; r,q
   inst* \e r1(r = r1 & r1 < y); r proved....

thm Remainder_mod
  y > 0 -> \e q(x = q*y+x mod y & x mod y < y)
proof 
 use Quotient_remainder.0; y; x
  eigen \e r(\e q x = y*q+r & r < y).0:0,3,0,1,0; r,q
   inst* \e q1 q = q1; q proved....

thm Quotient_remainder_div_mod
  y > 0 -> x = x/y*y+x mod y & x mod y < y
proof 
 use Quotient_remainder.0; y; x
  eigen \e r(\e q x = y*q+r & r < y).0:0,3,0,1,0; r,q proved...

thm Div_mono_le_left
  x <= y -> x/z <= y/z
proof 
 cut z = 0
  proved
  use Quotient_remainder.0; z; x
   use Quotient_remainder.0; z; y
    eigen \e r(\e q x = z*q+r & r < z).0:0,3,0,1,0; r1,q1
     eigen \e r(\e q y = z*q+r & r < z).0:0,3,0,1,0; r2,q2
      weak x = q1*z+r1
       weak y = q2*z+r2
        use Le_qr.1,0,2,0,0; z; r1; r2; q1; q2
         split q1 < q2 \/ q1 = q2 & r1 <= r2.4,0,0,0
          proved
          proved..........

rem 
  \para \bf  Divisibility predicate.  \end 

pred/2 Divides 'Tex_p2_pa_divides'
  Divides(x,y) <-> \e z y = x*z

thm Divides_reflexivity
  Divides(x,x)
proof 
 exp Divides; x,x
  inst* \e z x = x*z; 1 proved...

thm Divides_antisymmetry
  Divides(x,y) & Divides(y,x) -> x = y
proof 
 exp Divides; x,y
  eigen \e z y = x*z; z
   weak y = x*z
    exp Divides; x*z,x
     eigen \e z1 x = x*z*z1; z1
      cut x = 0
       proved
       proved.......

thm Divides_transitivity
  Divides(x,y) & Divides(y,z) -> Divides(x,z)
proof 
 exp Divides; x,z
  exp Divides; x,y
   eigen \e z1 y = x*z1; z1
    exp Divides; x*z1,z
     eigen \e z2 z = x*z1*z2; z2
      inst* \e z3 x*z1*z2 = x*z3; z1*z2 proved.......

thm Divides_left_zero
  Divides(0,x) <-> x = 0
proof 
 exp Divides; 0,x proved..

thm Divides_right_zero
  Divides(x,0)
proof 
 exp Divides; x,0
  inst* \e z z = 0; 0 proved...

thm Divides_left_one
  Divides(1,x)
proof 
 exp Divides; 1,x
  inst* \e z x = z; x proved...

thm Divides_right_one
  Divides(x,1) <-> x = 1
proof 
 exp Divides; x,1
  split* \e z z = 1 & x = 1 <-> x = 1.2,0,1,0,4,0,0,0
   proved
   inst* \e z z = 1; 1 proved.
   proved...

thm Divides_successor
  x > 1 -> ~Divides(x,y) \/ ~Divides(x,y+1)
proof 
 inv* ~Divides(x,y)
  inv* ~Divides(x,y+1)
   exp Divides; x,y
    eigen \e z y = x*z; z
     exp Divides; x,x*z+1 proved......

thm Divides_plus
  Divides(x,y) & Divides(x,z) -> Divides(x,y+z)
proof 
 exp Divides; x,y+z
  exp Divides; x,y
   eigen \e z1 y = x*z1; z1
    exp Divides; x,z
     eigen \e z2 z = x*z2; z2
      inst* \e z3 x*z1+x*z2 = x*z3; z1+z2 proved.......

thm Divides_minus
  Divides(x,y) & Divides(x,z) -> Divides(x,y-z)
proof 
 case Dich; y,z @ x1,y1; x1,y1
  use Divides_right_zero; x proved.
  exp Divides; x,y-z
   exp Divides; x,y
    eigen \e z1 y = x*z1; z1
     exp Divides; x,z
      eigen \e z2 z = x*z2; z2
       cut x = 0
        proved
        inst* \e z3 z1 = z2+z3; z1-z2 proved.........

thm Divides_times
  Divides(x,y) -> Divides(x,y*z)
proof 
 exp Divides; x,y*z
  exp Divides; x,y
   eigen \e z1 y = x*z1; z1
    inst* \e z2 x*z*z1 = x*z2; z*z1 proved.....

thm Divides_times_reflexivity
  Divides(x,x*y)
proof 
 use Divides_times; x; x; y
  use Divides_reflexivity; x proved...

thm Divides_bounded
  y > 0 & Divides(x,y) -> 0 < x & x <= y
proof 
 exp Divides; x,y
  eigen \e z y = x*z; z proved...

thm Divides_mod
  y > 0 & Divides(z,y) -> Divides(z,x mod y) <-> Divides(z,x)
proof 
 use Remainder_mod.1,0,4,0,0; y; x
  eigen \e q x = y*q+x mod y; q
   sym x = q*y+x mod y
    use Divides_times; z; y; q
     split* Divides(z,x mod y) <-> Divides(z,x).2,0,0
      use Divides_plus; z; x mod y; q*y proved.
      use Divides_minus; z; x; q*y proved.......

rem 
  \para \bf  Exponentiation.  \end 

fun/2 Exp 'Tex_f2_pa_exp'
  Exp(x,0) = 1
  Exp(x,y+1) = x*Exp(x,y)

thm Exp_zero
  Exp(x,y) = 0 <-> x = 0 & y > 0
proof 
 ind N; y @ 0; y
  proved
  split* x = 0 \/ x = 0 & y > 0 <-> x = 0.2,0,0
   split x = 0 \/ x = 0 & y > 0.4,0,0,0
    proved
    proved.
   proved...

thm Exp_one
  Exp(x,y) = 1 <-> x = 1 \/ y = 0
proof 
 ind N; y @ 0; y
  proved
  split* x = 1 & (x = 1 \/ y = 0) <-> x = 1.2,0,0
   proved
   proved...

thm Exp_plus
  Exp(x,y+z) = Exp(x,y)*Exp(x,z)
proof 
 ind N; y @ 0; y
  proved
  proved..

thm Exp_minus
  x > 0 & y >= z -> Exp(x,y-z) = Exp(x,y)/Exp(x,z)
proof 
 ind N; y; z @ 0; y
  proved
  case N; z @ 0; z1
   proved
   inst \a z(y >= z -> Exp(x,y-z) = Exp(x,y)/Exp(x,z)); z1 proved....

thm Exp_eq
  x > 1 -> Exp(x,y) = Exp(x,z) <-> y = z
proof 
 ind N; y; z @ 0; y
  use Exp_one.0; x; z proved.
  case N; z @ 0; z1
   proved
   inst \a z(Exp(x,y) = Exp(x,z) <-> y = z).0; z1 proved....

thm Exp_le
  x > 1 -> Exp(x,y) <= Exp(x,z) <-> y <= z
proof 
 ind N; y; z @ 0; y
  use Exp_zero.0; x; z proved.
  case N; z @ 0; z1
   use Exp_zero.0; x; y proved.
   inst \a z(Exp(x,y) <= Exp(x,z) <-> y <= z).0; z1 proved....

thm Exp_lt
  x > 1 -> Exp(x,y) < Exp(x,z) <-> y < z
proof 
 ind N; y; z @ 0; y
  cut z = 0
   proved
   use Exp_zero.0; x; z-1 proved..
  case N; z @ 0; z1
   use Exp_zero.0; x; y proved.
   inst \a z(Exp(x,y) < Exp(x,z) <-> y < z).0; z1 proved....

